// Copyright 2005 DJ Delorie
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "msg.h"

char *
paprintf(char *fmt, ...)
{
  va_list ap;
  char *buf;
  char tmp[100];
  int len;

  va_start(ap, fmt);

  len = vsnprintf(tmp, 100, fmt, ap);
  if (len < 100)
    {
      buf = strdup (tmp);
      return buf;
    }

  buf = (char *) malloc (len + 1);
  vsnprintf(buf, len+1, fmt, ap);
  return buf;
}

void
lprintf(int zone, char *fmt, ...)
{
  va_list ap;
  char *buf;
  char tmp[100];
  int len;

  va_start(ap, fmt);

  len = vsnprintf(tmp+1, 99, fmt, ap);
  if (len < 99)
    {
      tmp[0] = zone;
      Message lcd(tmp, strlen(tmp+1)+1, MT_lcd);
      lcd.send();
      return;
    }

  buf = (char *) malloc (len + 2);
  vsnprintf(buf+1, len+1, fmt, ap);
  buf[0] = zone;
  Message lcd(buf, strlen(buf+1)+1, MT_lcd);
  lcd.send();
  free (buf);

  return;
}
