// Copyright 2005 DJ Delorie
#include <stdio.h>
#include <ctype.h>

#define NEXTBYTE(lab) state = &&lab##_label; return; lab##_label:
#define DONEBYTE() state = 0; return

static void *state;
static int val;

void foo(char c)
{
  if (state)
    goto *state;

 unwrite:
  printf("top of write(), c = %c\n", c);

  if (c == 'x')
    {
      val = 0;
      while (1)
	{
	  NEXTBYTE(xdig);
	  if (isdigit(c))
	    val = val * 10 + c - '0';
	  else
	    {
	      printf("x val = %d, next char %c\n", val, c);
	      goto unwrite;
	    }
	}
    }
  else if (c == 'y')
    {
      NEXTBYTE(ydig);
      printf("y val %c\n", c);
    }
  else
    printf("regular char %c\n", c);

  DONEBYTE();
}
